import type { RequestParams } from '@elastic/elasticsearch';
import { Document } from '../common';
import { BoolQuery } from '../queries';
import { AggregationsContainer } from '../aggregations';
export type SearchRequest<TDocument extends Document, TAggregationsBody extends AggregationsContainer<TDocument>> = {
    size?: number;
    from?: number;
    query?: BoolQuery<TDocument>;
    aggregations?: TAggregationsBody;
};
export declare const getSearchRequest: <TDocument extends Document, TAggregationsBody extends AggregationsContainer<TDocument>>(index: string, options?: SearchRequest<TDocument, TAggregationsBody> | undefined) => RequestParams.Search<Record<string, any>>;
